Module javafx.base
Package javafx.beans.property

# Class ObjectProperty<T>

java.lang.Object
javafx.beans.binding.ObjectExpression<T>
javafx.beans.property.ReadOnlyObjectProperty<T>
javafx.beans.property.ObjectProperty<T>

Type Parameters:
  `T` - the type of the wrapped `Object`

All Implemented Interfaces:
  `Observable`, `Property<T>`, `ReadOnlyProperty<T>`, `ObservableObjectValue<T>`, `ObservableValue<T>`, `WritableObjectValue<T>`, `WritableValue<T>`

Direct Known Subclasses:
  `JavaBeanObjectProperty`, `ObjectPropertyBase`

public abstract class ObjectProperty<T> extends ReadOnlyObjectProperty<T> implements Property<T>, WritableObjectValue<T>
This class provides a full implementation of a `Property` wrapping an arbitrary `Object`. The value of a `ObjectProperty` can be get and set with `ObservableObjectValue.get()`, `ObjectExpression.getValue()`, `WritableObjectValue.set(Object)`, and `setValue(Object)`. A property can be bound and unbound unidirectional with `Property.bind(ObservableValue)` and `Property.unbind()`. Bidirectional bindings can be created and removed with `bindBidirectional(Property)` and `unbindBidirectional(Property)`. The context of a `ObjectProperty` can be read with `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()`. For specialized implementations for `ObservableList`, `ObservableSet` and `ObservableMap` that also report changes inside the collections, see `ListProperty`, `SetProperty` and `MapProperty`, respectively.

Since:
  JavaFX 2.0
See Also:
  - `ObservableObjectValue`
  - `WritableObjectValue`
  - `ReadOnlyObjectProperty`
  - `Property`

## Constructor Summary

Constructors
Constructor
Description
`ObjectProperty()`

## Method Summary

Modifier and Type
Method
Description
`void`
`bindBidirectional(Property<T> other)`
Create a bidirectional binding between this `Property` and another one.
`void`
`setValue(T v)`
Set the wrapped value.
`String`
`toString()`
Returns a string representation of this `ObjectProperty` object.
`void`
`unbindBidirectional(Property<T> other)`
Remove a bidirectional binding between this `Property` and another one.

### Methods inherited from class javafx.beans.binding.ObjectExpression

`asString, asString, asString, getValue, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotNull, isNull, objectExpression`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.beans.Observable

`addListener, removeListener`

### Methods inherited from interface javafx.beans.value.ObservableObjectValue

`get`

### Methods inherited from interface javafx.beans.value.ObservableValue

`addListener, getValue, removeListener`

### Methods inherited from interface javafx.beans.property.Property

`bind, isBound, unbind`

### Methods inherited from interface javafx.beans.property.ReadOnlyProperty

`getBean, getName`

### Methods inherited from interface javafx.beans.value.WritableObjectValue

`get, set`

### Methods inherited from interface javafx.beans.value.WritableValue

`getValue`

## Constructor Details

### ObjectProperty

public ObjectProperty()

## Method Details

### setValue

public void setValue(T v)
Set the wrapped value.

Specified by:
  `setValue` in interface `WritableValue<T>`
Parameters:
  `v` - The new value

### bindBidirectional

public void bindBidirectional(Property<T> other)
Create a bidirectional binding between this `Property` and another one. Bidirectional bindings exists independently of unidirectional bindings. So it is possible to add unidirectional binding to a property with bidirectional binding and vice-versa. However, this practice is discouraged.

It is possible to have multiple bidirectional bindings of one Property.

JavaFX bidirectional binding implementation use weak listeners. This means bidirectional binding does not prevent properties from being garbage collected.

Specified by:
  `bindBidirectional` in interface `Property<T>`
Parameters:
  `other` - the other `Property`

### unbindBidirectional

public void unbindBidirectional(Property<T> other)
Remove a bidirectional binding between this `Property` and another one. If no bidirectional binding between the properties exists, calling this method has no effect. It is possible to unbind by a call on the second property. This code will work:

>          property1.bindBirectional(property2);
>          property2.unbindBidirectional(property1);

Specified by:
  `unbindBidirectional` in interface `Property<T>`
Parameters:
  `other` - the other `Property`

### toString

public String toString()
Returns a string representation of this `ObjectProperty` object.

Overrides:
  `toString` in class `ReadOnlyObjectProperty<T>`
Returns:
  a string representation of this `ObjectProperty` object.